%global sdkver 1.3.283.0

Name:           glslang
Version:        14.2.0
Release:        2%{?dist}
Summary:        OpenGL and OpenGL ES shader front end and validator

License:        BSD-2-Clause AND BSD-3-Clause AND GPL-3.0-or-later AND Apache-2.0
URL:            https://github.com/KhronosGroup/%{name}
Source0:        %url/archive/vulkan-sdk-%{sdkver}.tar.gz#/%{name}-sdk-%{sdkver}.tar.gz
# Patch to build against system spirv-tools (rebased locally)
#Patch3:         https://patch-diff.githubusercontent.com/raw/KhronosGroup/glslang/pull/1722.patch#/0001-pkg-config-compatibility.patch
Patch3:         0001-pkg-config-compatibility.patch

BuildRequires:  cmake3
BuildRequires:  gcc-c++
BuildRequires:  ninja-build
BuildRequires:  python3
BuildRequires:  spirv-tools-devel

%description
%{name} is the official reference compiler front end for the OpenGL
ES and OpenGL shading languages. It implements a strict
interpretation of the specifications for these languages.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description    devel
%{name} is the official reference compiler front end for the OpenGL
ES and OpenGL shading languages. It implements a strict
interpretation of the specifications for these languages.

%prep
%autosetup -p1 -n %{name}-vulkan-sdk-%{sdkver}
# Fix rpmlint warning on debuginfo
find . -name '*.h' -or -name '*.cpp' -or -name '*.hpp'| xargs chmod a-x

%build
%cmake3 -DBUILD_SHARED_LIBS=OFF -DCMAKE_CXX_STANDARD_LIBRARIES="-lstdc++fs"
%cmake_build

%install
%{cmake_install}

# we don't want them in here
rm -rf %{buildroot}%{_includedir}/SPIRV

%files
%doc README.md README-spirv-remap.txt
%{_bindir}/glslang
%{_bindir}/glslangValidator
%{_bindir}/spirv-remap

%files devel
%{_includedir}/glslang/
%{_libdir}/libOSDependent.a
%{_libdir}/libSPIRV.a
%{_libdir}/libSPVRemapper.a
%{_libdir}/libglslang.a
%{_libdir}/libGenericCodeGen.a
%{_libdir}/libMachineIndependent.a
%{_libdir}/libglslang-default-resource-limits.a
%{_libdir}/pkgconfig/glslang.pc
%{_libdir}/pkgconfig/spirv.pc
%{_libdir}/cmake/*

%changelog
* Wed Sep 11 2024 José Expósito <jexposit@redhat.com> - 14.2.0-2
- RHEL 8 fixes
  Resolves: https://issues.redhat.com/browse/RHEL-54282

* Wed Sep 11 2024 José Expósito <jexposit@redhat.com> - 14.2.0-1
- Update to 1.3.283.0 SDK
  Resolves: https://issues.redhat.com/browse/RHEL-54282

* Wed Jul 12 2023 Dave Airlie <airlied@redhat.com> - 11.9.0-5
- Latest snapshot used in 1.3.250.1 sdk

* Mon Feb 13 2023 Dave Airlie <airlied@redhat.com> - 11.9.0-4
- Latest snapshot used in 1.3.239 sdk

* Wed Aug 24 2022 Dave Airlie <airlied@redhat.com> - 11.9.0-3
- Latest snapshot used in 1.3.224 sdk

* Mon Jun 20 2022 Dave Airlie <airlied@redhat.com> - 11.9.0-2
- Latest snapshot used in 1.3.216 sdk

* Mon Feb 21 2022 Dave Airlie <airlied@redhat.com> - 11.9.0-1.20220202.git2742e95
- Latest snapshot used in 1.3.204 sdk

* Wed Nov 04 2020 Dave Airlie <airlied@redhat.com> - 11.0.0-3
- Update glslang for 8.4.0

* Wed Aug 05 2020 Dave Airlie <airlied@redhat.com> - 11.0.0-1
- Update glslang for 8.3.0

* Wed Jan 29 2020 Dave Airlie <airlied@redhat.com> - 8.13.3559-1
- Update glslang for 8.2.0 for vulkan 1.2

* Sat Dec 07 2019 Dave Airlie <airlied@redhat.com> - 7.13.3496-2
- Update for 8.2.0

* Tue Nov 12 2019 Dave Airlie <airlied@redhat.com> - 7.13.3496-1
- Update to latest snapshot

* Thu Aug 15 2019 Dave Airlie <airlied@redhat.com> - 7.11.3214-4
- Fix coverity scans (Kamil Dudka)

* Sat Aug 03 2019 Dave Airlie <airlied@redhat.com> - 7.11.3214-3
- Latest upstream snapshot for validation layers build
- Add patch to build against system spirv-tools

* Tue Feb 12 2019 Dave Airlie <airlied@redhat.com> - 3.1-0.11.20190329.gite0d59bb
- Update for vulkan 1.1.92.0
- Update for vulkan 1.1.101.0

* Tue Aug 07 2018 Leigh Scott <leigh123linux@googlemail.com> - 3.1-0.10.20180727.gite99a268
- Update for vulkan 1.1.82.0

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 3.1-0.9.20180416.git3bb4c48
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Mon Apr 23 2018 Leigh Scott <leigh123linux@googlemail.com> - 3.1-0.8.20180416.git3bb4c48
- Update for vulkan 1.1.73.0

* Wed Mar 07 2018 Adam Williamson <awilliam@redhat.com> - 3.1-0.7.20180205.git2651cca
- Rebuild to fix GCC 8 mis-compilation
  See https://da.gd/YJVwk ("GCC 8 ABI change on x86_64")

* Fri Feb 09 2018 Leigh Scott <leigh123linux@googlemail.com> - 3.1-0.6.20180205.git2651cca
- Update for vulkan 1.0.68.0

* Fri Feb 09 2018 Leigh Scott <leigh123linux@googlemail.com> - 3.1-0.5.20171028.git715c353
- Use ninja to build

* Wed Feb 07 2018 Fedora Release Engineering <releng@fedoraproject.org> - 3.1-0.4.20171028.git715c353
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Wed Jan 03 2018 Leigh Scott <leigh123linux@googlemail.com> - 3.1-0.3.20171028.git715c353
- Exclude s390x and ppc64 from check section

* Wed Jan 03 2018 Leigh Scott <leigh123linux@googlemail.com> - 3.1-0.2.20171028.git715c353
- Add check section to run tests
- Split binaries into main package

* Thu Jul 13 2017 Leigh Scott <leigh123linux@googlemail.com> - 3.1-0.1.20171028.git715c353
- First build

